#!/usr/bin/python
import sys
import email
import base64
import quopri
import codecs
import imaplib

ga = imaplib.IMAP4_SSL('imap.gmail.com')
ga.login(sys.argv[1], sys.argv[2])

ga.select( sys.argv[3], True )
if sys.argv[4] == '1':
  typ, data = ga.search(None, 'UNSEEN')
else:
  typ, data = ga.search(None, 'ALL')
  
for num in data[0].split():
    typ, data = ga.fetch(num, '(RFC822)')
    raw_msg = data[0][1]
    
    body = ""
    got_plain = False
    msg = email.message_from_string(raw_msg)
    sub = msg.get('Subject')
    auth = msg.get('From')
    print "Start Message|%s|%s" % (auth,sub)

    if msg.is_multipart():
      for part in msg.walk():
        if part.get_content_type() == 'text/plain':
          next_body = part.get_payload()
          if next_body.find("Your email client does not support HTML messages") == -1:
            got_plain = True
             
            if part.as_string().find('Content-Transfer-Encoding: base64') != -1:
              try:
                next_body = base64.decodestring(next_body)
              except:
                next_body = next_body
        
            body = body + next_body
        
      # if there's no plain text try to get the HTML version, even though it formats poorly on the iPod
      if not got_plain:
        for part in msg.walk(): 
          if part.get_content_type() == 'text/html':
            next_body = part.get_payload()
        
            if part.as_string().find('Content-Transfer-Encoding: base64') != -1:
              try:
                next_body = base64.decodestring(next_body)
              except:
                next_body = next_body

            body = body + next_body
    
    else:
      body = msg.get_payload()

      if msg.as_string().find('Content-Transfer-Encoding: base64') != -1:
        try:
          body = base64.decodestring(body)
        except:
          body = body
                
    print body
    print "End Message"
        
ga.logout()
